$! Simple build procedure for ANSI compatible version which
$! will function cross platform
$!
$! Note that VMS is *NOT* defined.  All of the "VMS" pieces were, in fact,
$! VAX C pieces.  Using DEC C in ANSI mode, none are needed.)
$!
$! Builds everything as a SINGLE library
$! PROTO sets up the ANSI C form of RALCGM
$! SLAM_SHUT instructs it to close output files after it writes everything 
$!   to them
$ mycc :==cc/standard=ansi89/prefix=all/define=(PROTO,SLAM_SHUT)-
  /include=[-...]/object=[-.lib]/debug/noopt
$
$ set ver
$ copy mach.h [.include]
$ set def [.src]
$ mycc CGMATT.C
$ mycc CGMBEZ.C
$ mycc CGMCELL.C
$ mycc CGMCOLR.C
$ mycc CGMERR.C
$ mycc CGMFILE.C
$ mycc CGMFILL.C
$ mycc CGMFONT.C
$ mycc CGMGDP.C
$ mycc CGMGRAPH.C
$ mycc CGMHER.C
$ mycc CGMIBIN.C
$ mycc CGMICHAR.C
$ mycc CGMINPUT.C
$ mycc CGMITEXT.C
$ mycc CGMLIB.C
$! this gets included by another module
$! mycc CGMLOCAL.C
$ mycc CGMOBIN.C
$ mycc CGMOCHAR.C
$ mycc CGMOHPGL.C
$ mycc CGMOPS.C
$ mycc CGMOTEK.C
$ mycc CGMOTEXT.C
$!
$!  the X window driver is NOT included because the purpose of this
$!  build is to test the platform independent write to file capabilities
$!
$! mycc CGMOXW.C
$ mycc CGMPOLY.C
$ mycc CGMPROF.C
$ mycc CGMPTS.C
$ mycc CGMRAND.C
$ mycc CGMTEXT.C
$ mycc CGMTRAP.C
$ set def [-.lib]
$ library/object/create ralcgm.olb *.obj
$ delete *.obj.*
$!
$! now do the main, it shouldn't be in the library
$!
$ set def [-.src]
$!
$! The main doesn't belong in the library, neither do these other two, 
$! which can be used to build to build the fonts.
$!
$ mycc CGMMAIN.C
$ mycc GENBEZ.C
$ mycc GENHER.C
$!
$! These are also in the [.src] directory, but they aren't used, so don't
$! build them 
$!
$! mycc CGMOIGL.C
$! mycc CGMOTPZ.C
$! mycc CGMOVGA.C
$! mycc CGMSKEL.C
$!
$ set def [-]
$ link/exe=ralcgm.exe [.lib]cgmmain,ralcgm.olb/lib
$ link/exe=genbez.exe [.lib]genbez.obj,[.lib]ralcgm/lib
$ link/exe=genher.exe [.lib]genher.obj,[.lib]ralcgm/lib
$ set nover
$ write sys$output "RALCGM (file IO only!) is DONE"
