//TEST_SAVE_GRAPHICS.CC
// 
//  14-JUN-1997, David Mathog, Caltech
//    Create a window
//    Put several graphical objects into it
//    Pop up a checkbox dialog asking what type of graphics output
//    Pop down the dialog and output all graphical objects in the window
//
//  Yes, this looks a lot like the tutorial!!!
//  Yes, there could have been a few loops and less repeated code.
//
#include <amulet.h>

void Am_Save_To_GRAPHIC (Am_Object object, Am_String graphmode);

// a couple of globals to make it easier to invoke the graphic write
Am_String localgraphmode = "CLEAR_TEXT";
Am_Object my_win;
Am_Object graphics_buttons;
Am_Object doit_button;
Am_Object exit_button;

Am_Define_Method( Am_Object_Method, void, my_doit, (Am_Object cmd) )
{
  Am_Save_To_GRAPHIC (my_win, localgraphmode);
  cout << "wrote to a file" << endl << flush;
}
Am_Define_Method( Am_Object_Method, void, my_exit, (Am_Object cmd) )
{
  Am_Exit_Main_Event_Loop ();
}


Am_Define_Method( Am_Object_Method, void, my_setit, (Am_Object cmd) )
{
  localgraphmode = graphics_buttons.Peek(Am_VALUE);
  cout << "new color = " << (const char*)localgraphmode << endl << flush;
}

main (void)
{
  Am_Initialize ();

  my_win = Am_Window.Create ("my_win")
    .Set (Am_LEFT, 20)
    .Set (Am_TOP, 20)
    .Set (Am_WIDTH, 700)
    .Set (Am_HEIGHT, 500);
  Am_Screen.Add_Part (my_win);

  Am_Object my_win2 = Am_Window.Create ("my_win2")
    .Set (Am_LEFT, 400)
    .Set (Am_TOP, 20)
    .Set (Am_WIDTH, 200)
    .Set (Am_HEIGHT, 200);
  Am_Screen.Add_Part (my_win2);

  Am_Object my_arc1 = Am_Arc.Create ("my_arc1")
    .Set (Am_LEFT, 300)
    .Set (Am_TOP, 100)
    .Set (Am_HEIGHT, 100)
    .Set (Am_WIDTH, 100)
    .Set (Am_FILL_STYLE, Am_Blue)
    .Set (Am_LINE_STYLE, Am_No_Style);

  Am_Object my_arc2 = Am_Arc.Create ("my_arc2")
    .Set (Am_LEFT, 400)
    .Set (Am_TOP, 100)
    .Set (Am_HEIGHT, 50)
    .Set (Am_WIDTH, 100)
    .Set (Am_ANGLE1, 45)
    .Set (Am_ANGLE2,90)
    .Set (Am_FILL_STYLE, Am_Green)
    .Set (Am_LINE_STYLE, Am_Blue);

  Am_Object my_arc3 = Am_Arc.Create ("my_arc3")
    .Set (Am_LEFT, 500)
    .Set (Am_TOP, 100)
    .Set (Am_HEIGHT, 50)
    .Set (Am_WIDTH, 100)
    .Set (Am_ANGLE1,-45)
    .Set (Am_ANGLE2,90)
    .Set (Am_FILL_STYLE, Am_Blue)
    .Set (Am_LINE_STYLE, Am_No_Style);

  Am_Object my_arc4 = Am_Arc.Create ("my_arc4")
    .Set (Am_LEFT, 400)
    .Set (Am_TOP, 150)
    .Set (Am_HEIGHT, 50)
    .Set (Am_WIDTH, 100)
    .Set (Am_ANGLE1,45)
    .Set (Am_ANGLE2,-90)
    .Set (Am_FILL_STYLE, Am_Red)
    .Set (Am_LINE_STYLE, Am_No_Style);

  Am_Object my_arc5 = Am_Arc.Create ("my_arc5")
    .Set (Am_LEFT, 500)
    .Set (Am_TOP, 150)
    .Set (Am_HEIGHT, 50)
    .Set (Am_WIDTH, 100)
    .Set (Am_ANGLE1,-45)
    .Set (Am_ANGLE2,-90)
    .Set (Am_FILL_STYLE, Am_Red)
    .Set (Am_LINE_STYLE, Am_Green);


Am_Font font1( Am_FONT_FIXED, false, false, false, Am_FONT_SMALL );
Am_Font font2( Am_FONT_SERIF, true, false, false, Am_FONT_MEDIUM );
Am_Font font3( Am_FONT_SANS_SERIF, false, true, false, Am_FONT_LARGE );
Am_Font font4( Am_FONT_FIXED, false, false, true, Am_FONT_VERY_LARGE );

  Am_Object my_text1 = Am_Text.Create ("my_text1")
    .Set (Am_LEFT, 5)
    .Set (Am_TOP, 5)
    .Set (Am_TEXT, "This is small fixed text")
    .Set (Am_FONT, font1);
  Am_Object my_text1b = Am_Text.Create ("my_text1b")
    .Set (Am_LEFT, 170)
    .Set (Am_TOP, 5)
    .Set (Am_TEXT, "This is small blue fixed text")
    .Set (Am_LINE_STYLE, Am_Blue)
    .Set (Am_FONT, font1);
  Am_Object my_text1c = Am_Text.Create ("my_text1c")
    .Set (Am_LEFT, 355)
    .Set (Am_TOP, 5)
    .Set (Am_TEXT, "This is small red on green fixed text")
    .Set (Am_LINE_STYLE, Am_Red)
    .Set (Am_FILL_STYLE, Am_Green)
    .Set (Am_FONT, font1);
  Am_Object my_text2 = Am_Text.Create ("my_text2")
    .Set (Am_LEFT, 5)
    .Set (Am_TOP, 25)
    .Set (Am_TEXT, "This is medium bold serif text")
    .Set (Am_FONT, font2);
  Am_Object my_text3 = Am_Text.Create ("my_text3")
    .Set (Am_LEFT, 5)
    .Set (Am_TOP, 45)
    .Set (Am_TEXT, "This is large italic sans serif text")
    .Set (Am_FONT, font3);
  Am_Object my_text4 = Am_Text.Create ("my_text4")
    .Set (Am_LEFT, 5)
    .Set (Am_TOP, 65)
    .Set (Am_TEXT, "This is very large underlined fixed text")
    .Set (Am_FONT, font4);

  Am_Object my_rect = Am_Rectangle.Create ("my_rect")
    .Set (Am_LEFT, 10)
    .Set (Am_TOP, 100)
    .Set (Am_WIDTH, 180)
    .Set (Am_HEIGHT, 80)
    .Set (Am_LINE_STYLE, Am_No_Style)
    .Set (Am_FILL_STYLE, Am_Red);

  Am_Object my_rect2 = Am_Rectangle.Create ("my_rect2")
    .Set (Am_LEFT, 110)
    .Set (Am_TOP, 140)
    .Set (Am_WIDTH, 180)
    .Set (Am_HEIGHT, 80)
    .Set (Am_FILL_STYLE, Am_No_Style)
    .Set (Am_LINE_STYLE, Am_Red);

  Am_Style lred0 (1.0,0.0,0.0,0);
  Am_Style lred1 (1.0,0.0,0.0,1);
  Am_Style lred5 (1.0,0.0,0.0,5);
  Am_Style lred10 (1.0,0.0,0.0,10);
  Am_Object my_line1 = Am_Line.Create ("my_line1")
    .Set (Am_X1, 110)
    .Set (Am_Y1, 340)
    .Set (Am_X2, 180)
    .Set (Am_Y2, 280)
    .Set (Am_LINE_STYLE, lred0);
  Am_Object my_line2 = Am_Line.Create ("my_line2")
    .Set (Am_X1, 110)
    .Set (Am_Y1, 360)
    .Set (Am_X2, 180)
    .Set (Am_Y2, 300)
    .Set (Am_LINE_STYLE, lred1);
  Am_Object my_line3 = Am_Line.Create ("my_line3")
    .Set (Am_X1, 110)
    .Set (Am_Y1, 380)
    .Set (Am_X2, 180)
    .Set (Am_Y2, 320)
    .Set (Am_LINE_STYLE, lred5);
  Am_Object my_line4 = Am_Line.Create ("my_line4")
    .Set (Am_X1, 110)
    .Set (Am_Y1, 400)
    .Set (Am_X2, 180)
    .Set (Am_Y2, 340)
    .Set (Am_LINE_STYLE, lred10);
  Am_Object my_line5 = Am_Line.Create ("my_line5")
    .Set (Am_X1, 110)
    .Set (Am_Y1, 420)
    .Set (Am_X2, 180)
    .Set (Am_Y2, 360)
    .Set (Am_LINE_STYLE, lred0);


  Am_Point_List triangle_pl;
     triangle_pl      
        .Add (15, 50)
        .Add (45, 10)
        .Add (75, 50);

  Am_Point_List triangle_pl2;
     triangle_pl2
        .Add (15, 50)
        .Add (45, 10)
        .Add (75, 50)
        .Add (15, 50);

  Am_Object proto_polygon = Am_Polygon.Create ("proto_polygon")
    .Set (Am_POINT_LIST, triangle_pl)
    .Set (Am_LINE_STYLE, Am_Black)
    .Set (Am_FILL_STYLE, Am_Yellow);

  Am_Object my_polygon1 = proto_polygon.Create ("my_polygon1")
    .Set (Am_TOP, 300)
    .Set (Am_LEFT, 200);
  Am_Object my_polygon2 = proto_polygon.Create ("my_polygon2")
    .Set (Am_TOP, 300)
    .Set (Am_LEFT, 250)
    .Set (Am_FILL_STYLE, Am_No_Style);
//  Am_Object my_polygon3 = proto_polygon.Create ("my_polygon3")
//    .Set (Am_TOP, 300)
//    .Set (Am_LEFT, 300);
  Am_Object my_polygon3 = Am_Polygon.Create ("my_polygon3")
    .Set (Am_LINE_STYLE, Am_No_Style)
    .Set (Am_FILL_STYLE, Am_Yellow)
    .Set (Am_POINT_LIST, triangle_pl2)
    .Set (Am_TOP, 300)
    .Set (Am_LEFT, 300);
  Am_Object my_polygon4 = Am_Polygon.Create ("my_polygon4")
    .Set (Am_LINE_STYLE, Am_Blue)
    .Set (Am_FILL_STYLE, Am_No_Style)
    .Set (Am_POINT_LIST, triangle_pl2)
    .Set (Am_TOP, 300)
    .Set (Am_LEFT, 350);

  graphics_buttons = Am_Radio_Button_Panel.Create("graphics_buttons")
          .Set (Am_LEFT, 10)
          .Set (Am_TOP, 10)
          .Set (Am_ITEMS, Am_Value_List () // An Am_Value_List supports an arbitrary list
                .Add("BINARY")               // of dynamically typed values
                .Add("CHARACTER")
                .Add("CLEAR_TEXT")
                .Add("POSTSCRIPT")  //default
                .Add("HPGL"))
           .Set (Am_VALUE,"CLEAR_TEXT")
    .Set (Am_FILL_STYLE, Am_Motif_Gray);
   graphics_buttons.Get_Object(Am_COMMAND)
    .Set(Am_DO_METHOD, my_setit)
    ;

   doit_button = Am_Button.Create("doit_button")
          .Set (Am_LEFT, 10)
          .Set (Am_TOP, 140);
   doit_button.Get_Object(Am_COMMAND)
    .Set(Am_DO_METHOD, my_doit)
    .Set (Am_LABEL, "Do it")
    ;

   exit_button = Am_Button.Create("exit_button")
          .Set (Am_LEFT, 70)
          .Set (Am_TOP, 140);
   exit_button.Get_Object(Am_COMMAND)
    .Set(Am_DO_METHOD, my_exit)
    .Set (Am_LABEL, "Exit")
    ;



  my_win.Add_Part (my_arc1)
    .Add_Part (my_arc2)
    .Add_Part (my_arc3)
    .Add_Part (my_arc4)
    .Add_Part (my_arc5)
    .Add_Part (my_text1)
    .Add_Part (my_text1b)
    .Add_Part (my_text1c)
    .Add_Part (my_text2)
    .Add_Part (my_text3)
    .Add_Part (my_text4)
    .Add_Part (my_rect)
    .Add_Part (my_rect2)
    .Add_Part (my_line1)
    .Add_Part (my_line2)
    .Add_Part (my_line3)
    .Add_Part (my_line4)
    .Add_Part (my_line5)
    .Add_Part (my_polygon1)
    .Add_Part (my_polygon2)
    .Add_Part (my_polygon3)
    .Add_Part (my_polygon4)
    ;

//need to set up a region with all 3 fonts in all 4 styles
Am_Font fonttest10( Am_FONT_FIXED, false, false, false, Am_FONT_SMALL );
Am_Font fonttest11( Am_FONT_FIXED, true, false, false, Am_FONT_SMALL );
Am_Font fonttest12( Am_FONT_FIXED, false, true, false, Am_FONT_SMALL );
Am_Font fonttest13( Am_FONT_FIXED, false, false, true, Am_FONT_SMALL );
Am_Font fonttest20( Am_FONT_SERIF, false, false, false, Am_FONT_SMALL );
Am_Font fonttest21( Am_FONT_SERIF, true, false, false, Am_FONT_SMALL );
Am_Font fonttest22( Am_FONT_SERIF, false, true, false, Am_FONT_SMALL );
Am_Font fonttest23( Am_FONT_SERIF, false, false, true, Am_FONT_SMALL );
Am_Font fonttest30( Am_FONT_SANS_SERIF, false, false, false, Am_FONT_SMALL );
Am_Font fonttest31( Am_FONT_SANS_SERIF, true, false, false, Am_FONT_SMALL );
Am_Font fonttest32( Am_FONT_SANS_SERIF, false, true, false, Am_FONT_SMALL );
Am_Font fonttest33( Am_FONT_SANS_SERIF, false, false, true, Am_FONT_SMALL );

  Am_Object some_text;
  some_text = Am_Text.Create ("")
    .Set (Am_TOP, 360)
    .Set (Am_LEFT, 200)
    .Set (Am_TEXT, "1 = Fixed, 2 = Serif, 3 = Sans Serif")
    .Set (Am_FONT, fonttest10);
  my_win.Add_Part (some_text);

  some_text = Am_Text.Create ("")
    .Set (Am_TOP, 380)
    .Set (Am_LEFT, 200)
    .Set (Am_TEXT, ",0 = plain, ,1 = bold, ,2= italic, ,3=underline")
    .Set (Am_FONT, fonttest10);
  my_win.Add_Part (some_text);

  some_text = Am_Text.Create ("")
    .Set (Am_TOP, 400)
    .Set (Am_LEFT, 200)
    .Set (Am_TEXT, "[ 1 0 ]")
    .Set (Am_FONT, fonttest10);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 400)
     .Set(Am_LEFT,250)
     .Set (Am_TEXT, "[ 1 1 ]")
     .Set (Am_FONT, fonttest11);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 400)
     .Set(Am_LEFT,300)
     .Set (Am_TEXT, "[ 1 2 ]")
     .Set (Am_FONT, fonttest12);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 400)
     .Set(Am_LEFT,350)
     .Set (Am_TEXT, "[ 1 3 ]")
     .Set (Am_FONT, fonttest13);
  my_win.Add_Part (some_text);

  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 430)
     .Set (Am_LEFT, 200)
     .Set (Am_TEXT, "[ 2 0 ]")
     .Set (Am_FONT, fonttest20);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 430)
     .Set(Am_LEFT,250)
     .Set (Am_TEXT, "[ 2 1 ]")
     .Set (Am_FONT, fonttest21);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 430)
     .Set(Am_LEFT,300)
     .Set (Am_TEXT, "[ 2 2 ]")
     .Set (Am_FONT, fonttest22);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 430)
     .Set(Am_LEFT,350)
     .Set (Am_TEXT, "[ 2 3 ]")
     .Set (Am_FONT, fonttest23);
  my_win.Add_Part (some_text);

  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 460)
     .Set (Am_LEFT, 200)
     .Set (Am_TEXT, "[ 3 0 ]")
     .Set (Am_FONT, fonttest30);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 460)
     .Set(Am_LEFT,250)
     .Set (Am_TEXT, "[ 3 1 ]")
     .Set (Am_FONT, fonttest31);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 460)
     .Set(Am_LEFT,300)
     .Set (Am_TEXT, "[ 3 2 ]")
     .Set (Am_FONT, fonttest32);
  my_win.Add_Part (some_text);
  some_text = Am_Text.Create ("")
     .Set (Am_TOP, 460)
     .Set(Am_LEFT,350)
     .Set (Am_TEXT, "[ 3 3 ]")
     .Set (Am_FONT, fonttest33);
  my_win.Add_Part (some_text);

// test the image handling 
  char * pathname = Am_Merge_Pathname("lib/images/thekids.gif");
  Am_Image_Array image = Am_Image_Array(pathname);
  delete pathname;
  Am_Object bitmap = Am_Bitmap.Create("bitmap")
    .Set (Am_LEFT, 420)
    .Set (Am_TOP, 210)
    .Set (Am_IMAGE, image);
  my_win.Add_Part(bitmap);



  my_win2.Add_Part (graphics_buttons)
         .Add_Part (doit_button)
         .Add_Part (exit_button);

  /* ************************************************************ */
  Am_Main_Event_Loop ();
  Am_Cleanup ();
}
